// x y coordinates in

// x1 y1 x2 y2 out...

package ipl;
import futils.*;
import java.awt.Frame;
import java.awt.FileDialog;
import java.util.Vector;
import java.io.*;

public class Xy2vec   {

     public FileInputStream inputFile;

     public FileOutputStream outputFile;



     // Read xy data from the input file

     public void readPoints(PointList PL) {

          double x, y;

           inputFile =Futil.getFileInputStream();

  

          System.out.println("Processing input file");



          // Read input file (points) to PointList

          StreamTokenizer tokens = new StreamTokenizer(inputFile);



          // Make sure we don't have reading error

          try

               {

               while (tokens.nextToken() != tokens.TT_EOF)

                    {

                    x = tokens.nval;

                    tokens.nextToken();

                    y = tokens.nval;

                    PL.addPoint(x,y);

                    }

               System.out.println("Read input into list");

               }

          catch (IOException e) {

               System.out.println("Caught error: " + e);

               }



          // Make sure we can close the input file

          try {

               inputFile.close();

               }

          catch (IOException e) {

               System.out.println("Caught error: " + e);

               }

          } // readfPoints





   // Print vectors to output file

public void printOutData(Vector v) {

	outputFile = Futil.getFileOutputStream();

	PrintStream output = new PrintStream(outputFile);

    // Print to output file

    for (int i=0; i<v.size(); i++) {

    	Vec WITH=(Vec)v.elementAt(i);

        if (WITH.tail_is_empty == false)

        	output.println(WITH.head.x + " " +

            	WITH.head.y + " " +

                WITH.tail.x + " " +

                WITH.tail.y);

        }



    // Make sure we can close the output file

    try {

    	outputFile.close();

    }

    catch (IOException e) {

     	System.out.println("Caught error: " + e);

    }



    System.out.println("Output file has written");

}



public static void processImage(ProcessPlane pp) {

}



public static void main(String args[]) {



	// To store all Vec

    Vector v = new Vector();

    PointList pl = new PointList();

    Xy2vec x = new Xy2vec();

    // Read input data to pl(Vector)

    x.readPoints(pl);

    Points p = pl.popPoint();



    // While there is point in the list

    while (p != null) {

    boolean point_not_stashed = true;

    // Empty vector ?

    if (v.size() == 0) {

    	Vec W = new Vec(p);

        W.tail_is_empty = true;

        v.addElement(W);

        point_not_stashed = false;

    } else { 

    // Process new points, compare to existing Vecs

    	for (int i=0; (i<(int)v.size())&&point_not_stashed;i++) {

        	Vec newV = (Vec)v.elementAt(i);

            if (newV.head.isAdjacent(p)&&

            	newV.isSlopeAcceptable(p)) {

            	newV.addHead(p);

                point_not_stashed = false;

             }

             // Put new point to tail

             if (point_not_stashed) {

             	if ((newV.tail_is_empty &&

             		newV.head.isAdjacent(p))|| 

             		(!newV.tail_is_empty &&

             		newV.tail.isAdjacent(p)&&

             		newV.isSlopeAcceptable(p))) {

                    newV.addTail(p);

                    if (newV.tail_is_empty) {

                    	newV.tail_is_empty = false;

                        newV.getSlope();}

                    point_not_stashed = false;

                    }



                 }

              }// for

              // Put new point to head

              if (point_not_stashed) {

              	Vec nv = new Vec(p);

                nv.tail_is_empty = true;

                v.addElement(nv);

                point_not_stashed = false;

    		  }

    	}// else

    	p = pl.popPoint(); // Get new point

    }// while

	x.printOutData( v);
}
}

