package observers;
import java.util.*;

public class ObservableDouble extends NamedObservable {

private double value;     
     
public ObservableDouble(double newValue, String nm) {
	value = newValue;
	setName(nm);
}
     
public synchronized void setValue(double newValue) {
    if (newValue != value) {
       value = newValue;
       super.setChanged();     
       super.notifyObservers();    
    }
}

public synchronized double getValue() {
          return value;
   }
}